import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ProjectUser,
  ProjectUserParam
} from '@/api/tower/project/user/model/index';

/**
 * 分页查询项目成员
 */
export async function pageProjectUser(params: ProjectUserParam) {
  const res = await request.get<ApiResult<PageResult<ProjectUser>>>(
    '/tower/tower-project-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询项目成员列表
 */
export async function listProjectUser(params?: ProjectUserParam) {
  const res = await request.get<ApiResult<ProjectUser[]>>(
    '/tower/tower-project-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询项目成员
 */
export async function getProjectUser(id: number) {
  const res = await request.get<ApiResult<ProjectUser>>(
    '/tower/tower-project-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加项目成员
 */
export async function addProjectUser(data: ProjectUser) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-project-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改项目成员
 */
export async function updateProjectUser(data: ProjectUser) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-project-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除项目成员
 */
export async function removeProjectUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-project-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除项目成员
 */
export async function removeBatchProjectUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-project-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/tower/tower-project-user/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
